package core.thrift;

import org.apache.thrift.async.TAsyncClient;
import org.apache.thrift.transport.TNonblockingSocket;
import org.springframework.stereotype.Component;

import java.net.Socket;

@Component
public class TNonblockingSocketPool extends TTransportPool<TNonblockingSocket,TAsyncClient> {


    public TNonblockingSocketPool(SocketConfig config) {
        super(config);
    }

    @Override
    public Socket socket(TNonblockingSocket o) {
        return o.getSocketChannel().socket();
    }

    @Override
    public TNonblockingSocket create() throws Exception {
        return new TNonblockingSocket(config.ip,config.port,config.timeout);
    }


}
